/*
 * 商户退押金申请记录
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class MerchantDepositReturnsController : BaseController
    {
        public MerchantDepositReturnsController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 商户退押金申请记录列表

        /// <summary>
        /// 根据条件查询商户退押金申请记录列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(MerchantDepositReturns data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 根据条件查询商户退押金申请记录列表

        /// <summary>
        /// 商户退押金申请记录列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(MerchantDepositReturns data, string MerchantIdMerRealName, string MerchantIdMerchantMobile, string MerchantIdMerIdcardNo, string UserIdRealName, string UserIdMakerCode, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Fields.Add("CreateDate", "3"); //时间
            Fields.Add("AlipayAccountNo", "1"); //支付宝账号
            Fields.Add("OperateMan", "1"); //操作人

            string condition = " and Status>-1";
            //商户商户真实姓名
            if (!string.IsNullOrEmpty(MerchantIdMerRealName))
            {
                condition += " and MerchantId in (select MerchantId from PosMerchantInfoForMerRealName where MerRealName='" + MerchantIdMerRealName + "')";
            }
            //商户商户手机号
            if (!string.IsNullOrEmpty(MerchantIdMerchantMobile))
            {
                condition += " and MerchantId in (select MerchantId from PosMerchantInfoForMerchantMobile where MerchantMobile='" + MerchantIdMerchantMobile + "')";
            }
            //商户商户身份证号
            if (!string.IsNullOrEmpty(MerchantIdMerIdcardNo))
            {
                condition += " and MerchantId in (select MerchantId from PosMerchantInfoForMerIdcardNo where MerIdcardNo='" + MerchantIdMerIdcardNo + "')";
            }
            //创客真实姓名
            if (!string.IsNullOrEmpty(UserIdRealName))
            {
                condition += " and UserId in (select UserId from UserForRealName where RealName='" + UserIdRealName + "')";
            }
            //创客创客编号
            if (!string.IsNullOrEmpty(UserIdMakerCode))
            {
                condition += " and UserId in (select UserId from UserForMakerCode where MakerCode='" + UserIdMakerCode + "')";
            }


            Dictionary<string, object> obj = new AdminContent(_accessor.HttpContext, SystemPublicFuction.dbtables).IndexData("MerchantDepositReturns", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //商户
                int MerchantId = int.Parse(function.CheckInt(dic["MerchantId"].ToString()));
                PosMerchantInfo merchantid_PosMerchantInfo = db.PosMerchantInfo.FirstOrDefault(m => m.Id == MerchantId) ?? new PosMerchantInfo();
                dic["MerchantIdMerRealName"] = merchantid_PosMerchantInfo.MerRealName;
                dic["MerchantIdMerchantMobile"] = merchantid_PosMerchantInfo.MerchantMobile;
                dic["MerchantIdMerIdcardNo"] = merchantid_PosMerchantInfo.MerIdcardNo;
                dic.Remove("MerchantId");
                dic["StatusName"] = dic["Status"].ToString() == "1" ? "正常" : "关闭";
                //创客
                int UserId = int.Parse(function.CheckInt(dic["UserId"].ToString()));
                Users userid_Users = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                dic["UserIdRealName"] = userid_Users.RealName;
                dic["UserIdMakerCode"] = userid_Users.MakerCode;
                dic.Remove("UserId");

            }
            return Json(obj);
        }

        #endregion

        #region 增加商户退押金申请记录

        /// <summary>
        /// 增加或修改商户退押金申请记录信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 增加商户退押金申请记录

        /// <summary>
        /// 增加或修改商户退押金申请记录信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(MerchantDepositReturns data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();


            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContent(_accessor.HttpContext, SystemPublicFuction.dbtables).Add("MerchantDepositReturns", Fields, 0);
            AddSysLog(data.Id.ToString(), "MerchantDepositReturns", "add");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 修改商户退押金申请记录

        /// <summary>
        /// 增加或修改商户退押金申请记录信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            MerchantDepositReturns editData = db.MerchantDepositReturns.FirstOrDefault(m => m.Id == Id) ?? new MerchantDepositReturns();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改商户退押金申请记录

        /// <summary>
        /// 增加或修改商户退押金申请记录信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(MerchantDepositReturns data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();


            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContent(_accessor.HttpContext, SystemPublicFuction.dbtables).Edit("MerchantDepositReturns", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "MerchantDepositReturns", "update");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 删除商户退押金申请记录信息

        /// <summary>
        /// 删除商户退押金申请记录信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "MerchantDepositReturns", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContent(_accessor.HttpContext, SystemPublicFuction.dbtables).Edit("MerchantDepositReturns", Fields, id);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "MerchantDepositReturns", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContent(_accessor.HttpContext, SystemPublicFuction.dbtables).Edit("MerchantDepositReturns", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "MerchantDepositReturns", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContent(_accessor.HttpContext, SystemPublicFuction.dbtables).Edit("MerchantDepositReturns", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContent(_accessor.HttpContext, SystemPublicFuction.dbtables).Sort("MerchantDepositReturns", Sort, Id);

            AddSysLog(Id.ToString(), "MerchantDepositReturns", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.MerchantDepositReturns.Add(new MerchantDepositReturns()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "MerchantDepositReturns", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(MerchantDepositReturns data, string MerchantIdMerRealName, string MerchantIdMerchantMobile, string MerchantIdMerIdcardNo, string UserIdRealName, string UserIdMakerCode)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("CreateDate", "3"); //时间
            Fields.Add("AlipayAccountNo", "1"); //支付宝账号
            Fields.Add("OperateMan", "1"); //操作人


            string condition = " and Status>-1";
            //商户商户真实姓名
            if (!string.IsNullOrEmpty(MerchantIdMerRealName))
            {
                condition += " and MerchantId in (select MerchantId from PosMerchantInfoForMerRealName where MerRealName='" + MerchantIdMerRealName + "')";
            }
            //商户商户手机号
            if (!string.IsNullOrEmpty(MerchantIdMerchantMobile))
            {
                condition += " and MerchantId in (select MerchantId from PosMerchantInfoForMerchantMobile where MerchantMobile='" + MerchantIdMerchantMobile + "')";
            }
            //商户商户身份证号
            if (!string.IsNullOrEmpty(MerchantIdMerIdcardNo))
            {
                condition += " and MerchantId in (select MerchantId from PosMerchantInfoForMerIdcardNo where MerIdcardNo='" + MerchantIdMerIdcardNo + "')";
            }
            //创客真实姓名
            if (!string.IsNullOrEmpty(UserIdRealName))
            {
                condition += " and UserId in (select UserId from UsersForRealName where RealName='" + UserIdRealName + "')";
            }
            //创客创客编号
            if (!string.IsNullOrEmpty(UserIdMakerCode))
            {
                condition += " and UserId in (select UserId from UsersForMakerCode where MakerCode='" + UserIdMakerCode + "')";
            }


            Dictionary<string, object> obj = new AdminContent(_accessor.HttpContext, SystemPublicFuction.dbtables).IndexData("MerchantDepositReturns", Fields, "Id desc", "0", 1, 20000, condition, "MerchantId,AlipayAccountNo,ReturnAmount,OperateMan,UserId", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //商户
                int MerchantId = int.Parse(function.CheckInt(dic["MerchantId"].ToString()));
                PosMerchantInfo merchantid_PosMerchantInfo = db.PosMerchantInfo.FirstOrDefault(m => m.Id == MerchantId) ?? new PosMerchantInfo();
                dic["MerchantIdMerRealName"] = merchantid_PosMerchantInfo.MerRealName;
                dic["MerchantIdMerchantMobile"] = merchantid_PosMerchantInfo.MerchantMobile;
                dic["MerchantIdMerIdcardNo"] = merchantid_PosMerchantInfo.MerIdcardNo;
                dic.Remove("MerchantId");
                dic["StatusName"] = dic["Status"].ToString() == "1" ? "正常" : "关闭";
                //创客
                int UserId = int.Parse(function.CheckInt(dic["UserId"].ToString()));
                Users userid_Users = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                dic["UserIdRealName"] = userid_Users.RealName;
                dic["UserIdMakerCode"] = userid_Users.MakerCode;
                dic.Remove("UserId");

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            ReturnFields.Add("MerchantIdMerRealName", "商户商户真实姓名");
            ReturnFields.Add("MerchantIdMerchantMobile", "商户商户手机号");
            ReturnFields.Add("MerchantIdMerIdcardNo", "商户商户身份证号");
            ReturnFields.Add("AlipayAccountNo", "支付宝账号");
            ReturnFields.Add("ReturnAmount", "返还金额");
            ReturnFields.Add("OperateMan", "操作人");
            ReturnFields.Add("UserIdRealName", "创客真实姓名");
            ReturnFields.Add("UserIdMakerCode", "创客创客编号");

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "MerchantDepositReturns", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
